"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const queue_1 = require("../queue");
const capacity_full_exception_1 = require("../../../exceptions/capacity-full-exception");
class CapacityQueue extends queue_1.Queue {
    constructor(capacity) {
        super();
        this._capacity = capacity;
    }
    capacity() {
        return this._capacity;
    }
    isFull() {
        return this.length() >= this._capacity ? true : false;
    }
    enqueue(item) {
        if (this._items.length() < this.capacity()) {
            this._items.push(item);
        }
        else {
            throw new capacity_full_exception_1.CapacityFullException('Capacity Full');
        }
    }
}
exports.CapacityQueue = CapacityQueue;
//# sourceMappingURL=capacity-queue.js.map