"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const function_1 = require("./function");
describe('andThen', function () {
    it('should add 1 then triple', function () {
        let addOne = new function_1.Function((x) => x + 1);
        let triple = new function_1.Function((x) => x * 3);
        let combined = addOne.andThen(triple);
        expect(combined.apply(2)).toEqual(9);
    });
});
describe('compose', function () {
    it('should triple then add 1', function () {
        let addOne = new function_1.Function((x) => x + 1);
        let triple = new function_1.Function((x) => x * 3);
        let combined = addOne.compose(triple);
        expect(combined.apply(2)).toEqual(7);
    });
});
describe('identity', function () {
    it('should return parameter', function () {
        let addOne = new function_1.Function((x) => x + 1);
        expect(addOne.identity().apply(1)).toEqual(1);
    });
});
//# sourceMappingURL=function.spec.js.map